From a726c015867beffe15cc20ee22e32778678e8fdf Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?John=20H=C3=B6gberg?= <john@erlang.org>
Date: Mon, 10 Jun 2019 17:21:52 +0200
Subject: [PATCH 30/73] beam_ssa_type: Fix incorrect bitstring unit
 determination

The compiler would treat the "Unit" of bs_init instructions as
the unit of the result instead of the required unit of the input,
causing is_binary checks to be wrongly optimized away.
---
 lib/compiler/src/beam_ssa_type.erl    | 11 ++---------
 lib/compiler/test/beam_type_SUITE.erl | 14 ++++++++++++--
 2 files changed, 14 insertions(+), 11 deletions(-)

diff --git a/lib/compiler/src/beam_ssa_type.erl b/lib/compiler/src/beam_ssa_type.erl
index 57fd7fec608..68920e7dd31 100644
--- a/lib/compiler/src/beam_ssa_type.erl
+++ b/lib/compiler/src/beam_ssa_type.erl
@@ -840,15 +840,8 @@ type({bif,Bif}, Args, Ts, _Ds) ->
         Type ->
             Type
     end;
-type(bs_init, [#b_literal{val=Type}|Args], _Ts, _Ds) ->
-    case {Type,Args} of
-        {new,[_,#b_literal{val=Unit}]} ->
-            {binary,Unit};
-        {append,[_,_,#b_literal{val=Unit}]} ->
-            {binary,Unit};
-        {private_append,[_,_,#b_literal{val=Unit}]} ->
-            {binary,Unit}
-    end;
+type(bs_init, _Args, _Ts, _Ds) ->
+    {binary, 1};
 type(bs_extract, [Ctx], Ts, _Ds) ->
     #t_bs_match{type=Type} = get_type(Ctx, Ts),
     Type;
diff --git a/lib/compiler/test/beam_type_SUITE.erl b/lib/compiler/test/beam_type_SUITE.erl
index 2297c2e0f59..076a604aa47 100644
--- a/lib/compiler/test/beam_type_SUITE.erl
+++ b/lib/compiler/test/beam_type_SUITE.erl
@@ -24,7 +24,7 @@
 	 integers/1,numbers/1,coverage/1,booleans/1,setelement/1,
 	 cons/1,tuple/1,record_float/1,binary_float/1,float_compare/1,
 	 arity_checks/1,elixir_binaries/1,find_best/1,
-         test_size/1,cover_lists_functions/1,list_append/1]).
+         test_size/1,cover_lists_functions/1,list_append/1,bad_binary_unit/1]).
 
 suite() -> [{ct_hooks,[ts_install_cth]}].
 
@@ -48,7 +48,8 @@ groups() ->
        find_best,
        test_size,
        cover_lists_functions,
-       list_append
+       list_append,
+       bad_binary_unit
       ]}].
 
 init_per_suite(Config) ->
@@ -508,5 +509,14 @@ list_append(_Config) ->
     hello = id([]) ++ id(hello),
     ok.
 
+%% OTP-15872: The compiler would treat the "Unit" of bs_init instructions as
+%% the unit of the result instead of the required unit of the input, causing
+%% is_binary checks to be wrongly optimized away.
+bad_binary_unit(_Config) ->
+    Bin = id(<<1,2,3>>),
+    Bitstring = <<Bin/binary,1:1>>,
+    false = is_binary(Bitstring),
+    ok.
+
 id(I) ->
     I.

